function p=asgn(a,s)
% function p=asgn(a,s)
%
% constructor for an "abstract signal"
% with no arguments, produces an empty "asgn" element
%
% with a single element,
% produces a "data" type of "asgn" element: p.d=a
% 
% with two inputs, 
% produces a "signal" type of "asgn" element: p.n=a, p.r=s
%    where p.n is signal dimension, and p.r is its position reference
%

% Written by ameg@mit.edu,  last modified March 10, 2005

superiorto('lti')
superiorto('tf')
superiorto('ss')
superiorto('zpk')
superiorto('double')

global abstract_A;

if size(abstract_A,1)<1,
   error('you must run "newmodel" first')
end

if nargin==0,  % default definition
 p.n=1;
 p.r=0;
 p=class(p,'asgn');
 return
end

if nargin==2,
 p.n=round(a);
 p.r=round(s);
 p=class(p,'asgn');
 return
end

if isempty(a),
 p.n=1;
 p.r=0;
 p=class(p,'asgn');
 return
end

if nargin==1,
 p.d=a;
 p=class(p,'asgn');
 return;
end