function z=eq(x,y)
% function z=eq(x,y)
%
% equality constraints/feedback loop closure

% written by ameg@mit.edu,  last modified March 10, 2005

if ~(isa(x,'asgn')&isa(y,'asgn')), 
    error('invalid equality constraint')
end
if x.n~=y.n, 
    error('incompatible dimensions in equality constraint'); 
end

global abstract_A;
global abstract_B;
global abstract_C;    % state space C
global abstract_D;    % state space D
global abstract_m;    % number of inputs

if x.n>=abstract_m, error('too many equality constraints'); end

C=abstract_C(x.r+1:x.r+x.n,:)-abstract_C(y.r+1:y.r+y.n,:);
D=abstract_D(x.r+1:x.r+x.n,:)-abstract_D(y.r+1:y.r+y.n,:);
[U,S,V]=svd(D);
if S(x.n,x.n)<0.000001, error('cannot resolve equality constraint'); end
V1=V(:,1:x.n);
V2=V(:,x.n+1:abstract_m);
K=-V1*inv(S(1:x.n,1:x.n))*U'*C;
abstract_A=abstract_A+abstract_B*K;
abstract_B=abstract_B*V2;
abstract_C=abstract_C+abstract_D*K;
abstract_D=abstract_D*V2;
abstract_m=abstract_m-x.n;

z=1;
