function z=le(x,y)
% function z=le(x,y)
%
% transfer matrix from one signal to another

% written by ameg@mit.edu,  last modified March 10, 2005

global abstract_A;
global abstract_B;
global abstract_C;    % state space C
global abstract_D;    % state space D
global abstract_m;    % number of inputs

if y.n>=abstract_m, error('too many equality constraints'); end

Cx=abstract_C(x.r+1:x.r+x.n,:);
Cy=abstract_C(y.r+1:y.r+y.n,:);
Dx=abstract_D(x.r+1:x.r+x.n,:);
Dy=abstract_D(y.r+1:y.r+y.n,:);
[U,S,V]=svd(Dy);
if S(y.n,y.n)<0.000001, error('cannot resolve equality constraint'); end
V1=V(:,1:y.n);
Si=inv(S(1:y.n,1:y.n));
K=-V1*Si*U'*Cy;
R=V1*Si*U';
z=ss(abstract_A+abstract_B*K,abstract_B*R,Cx+Dx*K,Dx*R);
z=minlti(z);