function z=mtimes(x,y)
% function z=mtimes(x,y)
%
% z=x*y, x-matrix or LTI system, y-abstract signal

% written by ameg@mit.edu,  last modified March 10, 2005

if isa(x,'asgn'), error('incorrect signal multiplication'); end

global abstract_A;
global abstract_B;
global abstract_n;
global abstract_C;    % state space C
global abstract_D;    % state space D
global abstract_k;    % number of outputs

if isa(x,'double'),
    if isequal(size(x),[1 1]), 
        x=x*eye(y.n,y.n); 
    end
    if size(x,2)~=y.n, 
        error('incompatible dimensions in multiplication'); 
    end
    z=asgn(size(x,1),abstract_k);
    abstract_C=[abstract_C;x*abstract_C(y.r+1:y.r+y.n,:)];
    abstract_D=[abstract_D;x*abstract_D(y.r+1:y.r+y.n,:)];
    abstract_k=abstract_k+size(x,1);
    return
elseif isa(x,'lti'),
    [a,b,c,d]=ssdata(x);
    if size(d,2)~=y.n, error('incompatible dimensions'); end
    z=asgn(size(d,1),abstract_k);
    C=abstract_C(y.r+1:y.r+y.n,:);
    D=abstract_D(y.r+1:y.r+y.n,:);
    abstract_A=[abstract_A zeros(abstract_n,size(a,1));b*C a];
    abstract_B=[abstract_B;b*D];
    abstract_C=[abstract_C zeros(abstract_k,size(a,1));d*C c];
    abstract_D=[abstract_D;d*D];
    abstract_n=abstract_n+size(a,1);
    abstract_k=abstract_k+size(d,1);
else
    error('inadmissible signal multiplier')
end