function z=vertcat(varargin)
% function z=vertcat(varargin)
%
% z=[x1;x2;...;xm]

% written by ameg@mit.edu,  last modified March 10, 2005

global abstract_C;    % state space C
global abstract_D;    % state space D
global abstract_k;    % number of outputs

N=0;
for k=1:nargin,
    if ~isa(varargin{k},'asgn'),
        error('signal and non-signal concatenation')
    end
    n=varargin{k}.n;
    r=varargin{k}.r;
    abstract_C=[abstract_C;abstract_C(r+1:r+n,:)];
    abstract_D=[abstract_D;abstract_D(r+1:r+n,:)];
    N=N+n;
end
z=asgn(N,abstract_k);
abstract_k=abstract_k+N;

