function h2hi_test1(a)
% function h2hi_test1(a)
%
% test for h2hi, minimizing H2/H-Infinity norm of
%    1/(s+1)-((s-a)/(s+1))*K(s)

% written by ameg@mit.edu,  last modified March 10, 2005

if nargin<1, a=1; end
s=tf('s');
newmodel;
w=newsignal(1);
u=newsignal(1);
h=([1;s-a]/(s+1))*w;
e=[1 0]*h-u;
y=[0 1]*h;
[kh2,khi,gh2,ghi]=h2hi(w,u,e,y);

disp('H2 controller [(1-a)/((1+a)(s+a)) expected for a>0]:')
tf(kh2)
disp('H-Inf controller [-1/(1+a) expected for a>0]:')
tf(khi)