function [ki,gi]=h2hi_test2(tau,g,d)
% function [ki,gi]=h2hi_test2(tau,g,d)
%
% abstract signals clone of b05_ex7.m

if nargin<1, tau=0.1; end
if nargin<2, g=5; end
if nargin<3, d=1/150; end

s=tf('s');
j=sqrt(-1);

H0=exp(-tau)/(s-1)-(tau/(1+tau/2))/(1+tau*s/2);
W=(1+s)/(1+s/10);
w=linspace(0,100,10000);
H0w=squeeze(freqresp(H0,w));
Ww=squeeze(freqresp(W,w));
Hw=exp(-tau*j*w)./(j*w-1);
h=max(abs((H0w-Hw.')./Ww));
disp(['Weighted H-Infinity error: ' num2str(h)])

newmodel
w1=newsignal(1);
w2=newsignal(1);
u=newsignal(1);
y=g*w1-H0*u-(h*W/d)*w2;
e1=(1/(s+1))*y;
e2=d*u;
[k2,ki,g2,gi]=h2hi([w1;w2],u,[e1;e2],y);
norm(gi,Inf)
