function U=mininv(A,B,tol)
% function U=mininv(A,B,tol)
%
% minimal invariant subspace of A containing the columns of B
% tol: relative tolerance

% written by ameg@mit.edu, last modified 17.03.05

[n,m]=size(B);
if nargin<3, tol=n*(1e-8); end
U=zeros(n);
d=0;                                   % number of vectors taken from B
k=0;                                   % number of vectors already in U
while d<m,
    d=d+1;
    if norm(B(:,d))>tol,
        k=k+1;
        U(:,k)=B(:,d)/norm(B(:,d));
        break
    end
end
if k<1,
    U=zeros(n,0);
    return
end
while k<n,
    v=A*U(:,k);
    v=v-U(:,1:k)*(U(:,1:k)'*v);
    if norm(v)>tol,    
        v=v/norm(v);
        v=v-U(:,1:k)*(U(:,1:k)'*v);
        k=k+1;
        U(:,k)=v/norm(v);
    else
        if d>=m,
            break
        end
        while d<m,
            d=d+1;
            v=B(:,d);
            v=v-U(:,1:k)*(U(:,1:k)'*v);
            if norm(v)>tol,
                v=v/norm(v);
                v=v-U(:,1:k)*(U(:,1:k)'*v);
                k=k+1;
                U(:,k)=v/norm(v);
                break
            end
        end
    end
end
U=U(:,1:k);
                