function Gr=minlti(G,tol)
% function Gr=minlti(G,tol)
%
% a model reduction program, used for compatibility with SCILAB
% and to avoid "minreal.m" dupms
% tol: relative tolerance for Hankel singular value elimination
%      (default value tol=1e-8)

% written by ameg@mit.edu


%Gr=minreal(G,tol);
[a,b,c,d]=ssdata(G);      % state space data
n=size(b,1);
if nargin<2, tol=n*(1e-8); end
if (norm(b)<n*tol)|(norm(c)<n*tol),
    Gr=ss([],[],[],d);
    return;
end
r=sqrt(norm(b)/norm(c));   % normalization factor
b=b/r;
c=c*r;
U=mininv(a,b,tol);
if isempty(U),
    Gr=ss([],[],[],d);
    return;
end    
a=U'*a*U;
b=U'*b;
c=c*U;
U=mininv(a',c',tol);
if isempty(U),
    Gr=ss([],[],[],d);
    return;
end 
a=U'*a*U;
b=U'*b;
c=c*U;
Gr=ss(a,b,c,d);